#ifndef alien_h
#define alien_h

#include "sprite.h"
#include "mlist.h"
#include "type.h"
#include "debris.h"

#define ALIEN struct alien

enum alien_STATES { alien_ALIVE, alien_DEBRIS, alien_GONE };

struct alien {
    SPRITE *sprite;
    MLIST *missiles;
    DEBRIS *debris;
    enum alien_STATES state;
};

ALIEN *alien_Create();
void alien_Destroy();

void alien_Start();
void alien_Update();
void alien_Cancel();

boolean alien_CheckCollisions();
int alien_HitMissile();

#define alien_State(a) ((a)->state)
#define alien_Missiles(a) ((a)->missiles)

#endif
