#ifdef aiws
#include <fcntl.h>
#endif
#include <sys/file.h>
#include "apa16.h"

u_short *_apa16_Queue;
int _apa16_oldX, _apa16_oldY;
u_short *_apa16_SaveArea;

int apa16_Init()
{
#ifndef aiws
    if (open("/dev/apa16", O_RDWR) < 0)
        return -1;
#endif

    apa16_ResetAdapter();
    apa16_Control(apa16_Status() | 0x400);
    apa16_EnableOutput();

    _apa16_Queue = apa16_QueueMax;
    apa16_QueuePtr = apa16_AddrToQueue(_apa16_Queue);

    _apa16_oldX = _apa16_oldY = -1;
    _apa16_SaveArea = (u_short *) malloc(1024 * 768 / 8);

    return 0;
}

void apa16_Run()
{
#ifdef notdef
    if (apa16_QueueCounter > 1000)
        while (apa16_QueueCounter > 500)
            ;
#else
	sleep(1);
#endif

    _apa16_Queue[1] |= apa16_DecQueueCounter;
    apa16_IncQueueCounter();
    _apa16_oldX = _apa16_oldY = -1;
}

void apa16_Fill(x, y, w, h, fn)
int x, y, w, h, fn;
{
    apa16_Load(0x7, x+w);
    apa16_Load(0x6, y+h);
    apa16_Load(0x9, w);
    apa16_Load(0x8, h);
    apa16_Execute(op_Fill, fn);
    _apa16_oldX = _apa16_oldY = -1;
}

void apa16_Copy(dx, dy, sx, sy, w, h, fn)
int dx, dy, sx, sy, w, h, fn;
{
    apa16_Load(0x7, dx+w);
    apa16_Load(0xa, dy+h);
    apa16_Load(0x5, sx+w);
    apa16_Load(0x4, sy+h);
    apa16_Load(0x9, w);
    apa16_Load(0x0, h);
    apa16_Execute(op_Copy, fn);
    _apa16_oldX = _apa16_oldY = -1;
}

void apa16_DrawNull(x, y, fn)
int x, y, fn;
{
    apa16_Load(0x5, x);
    apa16_Load(0x6, y);
    apa16_Execute(op_DrawNull, fn);
}

void apa16_RelMove(x, y)
int x, y;
{
    apa16_Load(0x1, x);
    apa16_Load(0x0, y);
    apa16_Execute(op_RelMove, 0);
}

void apa16_RelDraw(x, y, fn)
int x, y, fn;
{
    apa16_Load(0x5, x);
    apa16_Load(0x6, y);
    apa16_Execute(op_RelDraw, fn);
}

void apa16_RelDrawNull(x, y, fn)
int x, y, fn;
{
    apa16_Load(0x5, x);
    apa16_Load(0x6, y);
    apa16_Execute(op_RelDrawNull, fn);
}
