#ifndef bitmap_h
#define bitmap_h

#include "type.h"

#define bitmap_WHITE 0
#define bitmap_BLACK 1
#define bitmap_INVERT 2

struct bitmap {
    unsigned int width;
    unsigned int height;
    unsigned int freeBits;
    unsigned char *bits;
};

#define BITMAP struct bitmap

BITMAP *bitmap_Create();
BITMAP *bitmap_Display();
void bitmap_Destroy();

void bitmap_ClearWhite();
void bitmap_ClearBlack();
void bitmap_Invert();

void bitmap_SetLine();
void bitmap_ResLine();
void bitmap_InvLine();

#define bitmap_Width(r) ((r)->width)
#define bitmap_Height(r) ((r)->height)
#define bitmap_Bits(r) ((char *) (r)->bits)

#endif bitmap_h
