struct bitmap *r;
unsigned long x0, y0, x1, y1;
{
    register BM_WORD b, *s;
    register int dx, dy;
    register unsigned int linelen = r->width / BM_WORD_WIDTH;
    register int errterm, errdec, errinc;

    s = (BM_WORD *)r->bits + linelen * y0 + (x0 / BM_WORD_WIDTH);

#define LOOP(maxdelta, mindelta, majorop, minorop) 	\
    {							\
	errterm = 2 * mindelta - maxdelta;		\
	errdec = errterm - maxdelta;			\
	errinc = errterm + maxdelta;			\
	while (maxdelta--) {				\
                if (errterm > 0) {                      \
                        errterm += errdec;              \
			minorop;			\
		} else					\
			errterm += errinc;		\
                majorop;				\
		MERGE(s,b);				\
	}						\
    }

#ifdef BM_MSBLEFT
    b = MSBit >> (BM_WORD) (x0 & BM_WORD_MASK);
#else
    b = LSBit << (BM_WORD) (x0 & BM_WORD_MASK);
#endif

    MERGE(s,b);

    if (x0 < x1) {
        if (y0 < y1) {
            dx = x1 - x0; dy = y1 - y0;
            if (dx > dy)
                LOOP(dx, dy, RIGHT(s,b), DOWN(s,b))
            else
                LOOP(dy, dx, DOWN(s,b), RIGHT(s,b))
        } else {
            dx = x1 - x0; dy = y0 - y1;
            if (dx > dy)
                LOOP(dx, dy, RIGHT(s,b), UP(s,b))
            else
                LOOP(dy, dx, UP(s,b), RIGHT(s,b))
        }
    } else {
        if (y0 < y1) {
            dx = x0 - x1; dy = y1 - y0;
            if (dx > dy)
                LOOP(dx, dy, LEFT(s,b), DOWN(s,b))
            else
                LOOP(dy, dx, DOWN(s,b), LEFT(s,b))
        } else {
            dx = x0 - x1; dy = y0 - y1;
            if (dx > dy)
                LOOP(dx, dy, LEFT(s,b), UP(s,b))
            else
                LOOP(dy, dx, UP(s,b), LEFT(s,b))
        }
    }
}
