#ifndef bytemap_h
#define bytemap_h

#include "type.h"

#define ras_WHITE 0
#define ras_BLACK 1
#define ras_INVERT 2

struct bytemap {
    int width;
    int height;
    u_char *bytes;
    int freeBytes;
};

#define BYTEMAP struct bytemap

BYTEMAP *bytemap_Create();
BYTEMAP *bytemap_Display();
void bytemap_Destroy();

void bytemap_ClearWhite();
void bytemap_ClearBlack();
void bytemap_Invert();

void bytemap_SetLine();
void bytemap_ResLine();
void bytemap_InvLine();

#define bytemap_Width(r) ((r)->width)
#define bytemap_Height(r) ((r)->height)
#define bytemap_Bytes(r) ((char *) (r)->bytes)

#endif bytemap_h
