#ifndef debris_h
#define debris_h

#include "sprite.h"
#include "vect.h"
#include "frac.h"

#define DEBRIS struct debris

#define MAXDEBRIS 25

struct debris {
    SPRITE *pieces[MAXDEBRIS];
    VECT directions[MAXDEBRIS];
    int fizzled[MAXDEBRIS];
    VECT pos,vel;
    int num,left,size,offs;
    FRAC radius;
};

DEBRIS *debris_Create();
void debris_Destroy(),debris_Update();
void debris_Start(),debris_On(),debris_Off();
#define debris_IsClear(d) ((d)->left==0)
#define debris_SetPos(d,v) vect_Copy(&(d)->pos,(v))
#define debris_SetVel(d,v) vect_Copy(&(d)->vel,(v))
#define debris_Stop(d) debris_Off(d)

#endif debris_h
