#include "extras.h"
#include "param.h"

EXTRAS *extras_Create()
{
    EXTRAS *e = New(EXTRAS);
    int i;

    for (i = 0; i < MAXEXTRA; i++) {
        /* Not good: ship should have copies of sprite macros. */
        SHIP *sh = ship_Create();
        SPRITE *sp = ship_GetSprite(sh);
        VECT v;
        e->ships[i] = sh;
        ship_Start(sh);
        sprite_SetInc(sp, 1);
        vect_SetXY(&v, EXTRAX + 32*i, SCOREBARH/2);
        sprite_SetPos(sp, &v);
        sprite_SetBounds(sp, 1, HIGHX - 100, 1, SCOREBARH - 1);
        sprite_SetWrap(sp, FALSE);      /* In case too many */
    }

    e->areOn = e->oldAreOn = FALSE;
    e->count = e->oldCount = 0;

    return e;
}

void extras_Destroy(e)
EXTRAS *e;
{
    int i;
    for (i = 0; i < MAXEXTRA; i++)
        ship_Destroy(e->ships[i]);
    Zap(e);
}

void extras_Update(e)
EXTRAS *e;
{
    int i;

    if (e->oldAreOn)
        if (! e->areOn || e->count != e->oldCount)
            for (i = 0; i < e->oldCount; i++)
                ship_Off(e->ships[i]);

    if (e->areOn)
        if (! e->oldAreOn || e->count != e->oldCount)
            for (i = 0; i < e->count; i++)
                ship_On(e->ships[i]);

    for (i = 0; i < e->count; i++)
        ship_Update(e->ships[i]);

    e->oldAreOn = e->areOn;
    e->oldCount = e->count;
}
