#ifndef game_h
#define game_h

#include "score.h"
#include "ship.h"
#include "extras.h"
#include "alien.h"
#include "updlist.h"
#include "asteroids.h"

#define GAME struct game

enum game_TURNSTATE {
    game_ATTRACT,
    game_WAIT,
    game_ACTIVE,
    game_BOOM,
    game_QUIT,
    game_DEAD
};

struct game {
    LINEFONT *scoreFont;
    SCORE *score;
    int scoreThreshold;
    SHIP *ship;
    EXTRAS *extras;
    ASTEROIDS *aster;
    ALIEN *alien;
    UPDLIST *updates;
    int level, player;
    enum game_TURNSTATE tst;
};

void game_GlobalInit();

GAME *game_Create();
void game_Destroy();
int game_Attract();

int game_Turn();

#define game_GetScore(g) ((g)->score)
#define game_AddUpdate(g,i,p) updlist_Add((g)->updates,(i),(p))

#define game_GetAster(g) ((g)->aster)
#define game_GetAlien(g) ((g)->alien)
#define game_GetShip(g) ((g)->ship)
#define game_GetTurnstate(g) ((g)->tst)

#endif game_h
