#include "ghost.h"

#define GHOSTBLINKINTERVAL 8       /* Move to param.h */

char *sprintf();

GHOST *ghost_Create(player)
int player;
{
    GHOST *g = New(GHOST);
    char buf[80];
    VECT fontSize, textSize, screenSize, textPos;

    g->text=text_Create();
    g->ghostship = ship_Create();
    ship_Start(g->ghostship);
    g->ghostclock = 0;

    sprintf(buf,"Player %d", player+1);
    text_Set(g->text, buf);

    vect_SetXY(&fontSize,5,1);
    g->font=linefont_Create(&fontSize,0);
    text_SetFont(g->text,g->font);
    text_GetSize(g->text,&textSize);
    plot_GetSize(&screenSize);
    vect_SetXY(&textPos,
	       (vect_GetX(&screenSize)-vect_GetX(&textSize)) / 2 + 8,
	       (vect_GetY(&screenSize)-vect_GetY(&textSize)) / 2 +
                4 * shape_GetRadius(ship_GetCurShape(g->ghostship)));
    text_SetPos(g->text, &textPos);
    text_On(g->text);

    return g;
}

void ghost_Destroy(g)
GHOST *g;
{
    text_Destroy(g->text);
    linefont_Destroy(g->font);
    ship_Destroy(g->ghostship);
    Zap(g);
}

void ghost_Update(g)
GHOST *g;
{
    text_Update(g->text);

    g->ghostclock++;
    if (g->ghostclock == 2 * GHOSTBLINKINTERVAL) {
        g->ghostclock = 0;
        ship_On(g->ghostship);
    } else if (g->ghostclock == GHOSTBLINKINTERVAL)
        ship_Off(g->ghostship);

    ship_Update(g->ghostship);
}
