#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>
#define XK_MISCELLANY
#include <X11/keysymdef.h>
#include "type.h"
#include "input.h"
#include "plot.h"
#include "util.h"

boolean input_GlobalInit()
{
}

void input_Done()
{
}

enum input_Status input_Poll(key, delay)
enum input_Key *key;
struct timeval *delay;
{
    enum input_Status result;
    char    sign;
    KeySym  keysym;
    XEvent event;

    plot_Flush(); /* make sure all output is visible */

    if (XPending(plot_display))
	XNextEvent(plot_display, &event);
    else
	return input_NONE;
    


    XLookupString(&event, &sign, 1, &keysym, NULL);

    switch (event.type) {
    case KeyPress:
	result = input_KEYDOWN;
	break;
    case KeyRelease:
	result = input_KEYUP;
	break;
    default:
	return input_NONE;
    }
    switch (keysym) {
#ifdef HP
# define KEY_LEFT	XK_z           /* Changed by RKL */
# define KEY_RIGHT	XK_x           /* Changed by RKL */
# define KEY_THRUST	XK_Shift_R
# define KEY_FIRE	XK_Return      /* Changed by RKL */
#efif 0
# define KEY_LEFT	XK_Control_L
# define KEY_RIGHT	XK_Shift_L
# define KEY_THRUST	XK_Shift_R
# define KEY_FIRE	XK_Return
#else
# define KEY_LEFT	XK_Left
# define KEY_RIGHT	XK_Right
# define KEY_THRUST	XK_Up
# define KEY_FIRE	XK_Return
#endif
    case KEY_LEFT:
    case XK_Z:                  /* Added by RKL */
        *key = key_ROTLEFT;
	break;
    case KEY_RIGHT:
    case XK_X:                 /* Added by RKL */
        *key = key_ROTRIGHT;
	break;
    case KEY_THRUST:
#ifdef HP
    case XK_Shift_L:		/* Added by RKL to allow either SHIFT */
#endif /* HP */
        *key = key_THRUST;
        break;
    case KEY_FIRE:
        *key = key_FIRE;
        break;
    case XK_space:
    case XK_h:                 /* Both lines added by RKL */
    case XK_H:
        *key = key_HYPERSPACE;
        break;
    case XK_p:
    case XK_P:
        *key = key_PAUSE;
	break;
    case XK_q:
    case XK_Q:
        *key = key_QUIT;
        break;
    case XK_1:
        *key = key_START;
        break;
    case XK_2:
	*key = key_START_2;
        break;
    case XK_s:
    case XK_S:
        *key = key_TOGGLESOUND;
        break;
    default:
        return input_NONE;
    }
    return result;
}
