#ifndef line_h
#define line_h

#include "vect.h"

#define LINE struct line

struct line {
    VECT f, t;
};

#define line_SetF(l, v) \
        vect_Copy(&(l)->f, (v))
#define line_GetF(l, v) \
        vect_Copy((v), &(l)->f)
#define line_RefF(l) \
        (&(l)->f)

#define line_SetT(l, v) \
        vect_Copy(&(l)->t, (v))
#define line_GetT(l, v) \
        vect_Copy((v), &(l)->t)
#define line_RefT(l) \
        (&(l)->t)

#define line_SetFT(l, vf, vt) \
        (line_SetF((l), (vf)), \
         line_SetT((l), (vt)))
#define line_GetFT(l, vf, vt) \
        (line_GetF((l), (vf)), \
         line_GetT((l), (vt)))

#define line_Copy(l1, l2) \
	(*(l1) = *(l2))

#define line_AddVect(l, v) \
        (vect_Add(&(l)->f, (v)), \
         vect_Add(&(l)->t, (v)))
#define line_SubVect(l, v) \
        (vect_Sub(&(l)->f, (v)), \
         vect_Sub(&(l)->t, (v)))

#endif line_h
