#include "type.h"
#include "missile.h"
#include "param.h"

/* if true, missiles bounce off edge, otherwise they wrap */
static boolean bounce=FALSE;

void missile_GlobalSetBounce(b)
boolean b;
{
    bounce=b;
}

static LINE line={{-1,0},{1,0}};

static SHAPE *casing=NULL;

void missile_GlobalInit()
{
    casing=shape_Create();
    shape_Insert(casing,&line);
}

MISSILE *missile_Create()
{
    VECT screen;
    MISSILE *m=New(MISSILE);

    plot_GetSize(&screen);

    m->timeout=0;
    m->sprite=sprite_Create();
    sprite_SetShapes(m->sprite, &casing, 1);
    sprite_SetBounds(m->sprite,
		     1,vect_GetX(&screen)-2,SCOREBARH+1,vect_GetY(&screen)-2);

    if(bounce)
	sprite_SetBounce(m->sprite,TRUE);
    else
	sprite_SetWrap(m->sprite,TRUE);

    return m;
}

void missile_Destroy(m)
MISSILE *m;
{
    sprite_Destroy(m->sprite);
    Zap(m);
}

void missile_Update(m)
MISSILE *m;
{
    if(sprite_IsOn(m->sprite)){
	if(m->timeout>0)
	    m->timeout--;
	else
	    sprite_Off(m->sprite);
    }
    sprite_Update(m->sprite);
}

boolean missile_HitSprite(m, s)
MISSILE *m;
SPRITE *s;
{
    LINE l;
    vect_Copy(line_RefF(&l), sprite_RefPos(m->sprite));
    vect_Copy(line_RefT(&l), sprite_RefOldPos(m->sprite));
    vect_Sub(line_RefF(&l), sprite_RefPos(s));
    vect_Sub(line_RefT(&l), sprite_RefPos(s));
    return shape_LineTouches(sprite_GetCurShape(s), &l);
}
