#ifndef param_h
#define param_h

/*
 * Ship
 */

#define SHIPSHOTSPEED 25
#define SHIPSHOTRANGE 64        /* Missile duration */
#define MISSILELIMIT 6
#define HYPERCOUNT 50           /* Duration of hyperspace */
#define SHIPROTATIONS 50        /* Fineness of ship rotation */
#define STARTLIVES 5            /* Less than MAXEXTRA */
#define MAXEXTRA 10             /* Maximum of extra ships */
#define EXTRAMANINTERVAL 10000

/*
 * Alien
 */

#define ALIENSHOTSPEED 25
#define ALIENSHOTRANGE 64
#define ALIENCLUMSINESS 50      /* Rarety of alien direction changes */
#define ALIENCREATIONPROB 50	/* Rarety of alien creation */
#define ALIENSIZES 2

/*
 * Asteroids
 */

#define INITWAVESIZE 5          /* Initial # of large asts in a game */
#define WAVEDELAY 100           /* Time before new set of asts */
#define ASTSIZES 3
#define ASTROTATIONS 144
#define MAXASTVEL 5
#define MAXASTROT 3

/*
 * Explosions
 */

#define SHARDMAX 120            /* Number of shards */
#define SHARDMAXLEN 30          /* Size of shards */
#define SHARDSPIN 10
#define SHARDVEL 10

/*
 * Scoring:
 *  Asteroid sizes are 0 (biggest), 1, 2, ...
 *  Score for asteroids is (MULASTSCORE * size + BASEASTSCORE)
 *  Alien sizes are 0 (small), 1, ...
 *  Score for aliens is (MULALIENSCORE * size + BASEALIENSCORE)
 */

#define BASEASTSCORE 10
#define MULASTSCORE 20

#define BASEALIENSCORE 100
#define MULALIENSCORE 200

/*
 * Screen positioning
 */

#define SCOREBARH 64		/* height of score area at top */

#define EXTRAX 100		/* x coord of extra-ship display */
#define SCOREX 400		/* x coord of current score */
#define HIGHX 800		/* x coord of high score */

/*
 * high score stuff
 */

#define HIGHROWS 6              /* # rows of high scores */
#define HIGHCOLS 3              /* # cols of high scores */

#define PERMSCORES HIGHROWS		/* number of hs's that are permanent */
#define SCORETIMEOUT (2*7*24*60*60)	/* seconds non-permanent scores last */

#ifndef HIGHSCOREFILE
#define HIGHSCOREFILE \
   "/home/hyperion/mu/christos/lib/.asteroids"
#endif

/*
 * Timing
 */

#define LOOPPERIOD 30000   /* uSeconds per frame */
#define DEETPERIOD 12      /* frames per `deet' sound effect */

#endif param_h
