#ifndef aiws
#include <machinecons/apa16tty.h>
#else
#define SCREEN_WD 1024
#define SCREEN_HT 768
#endif

#include "type.h"
#include "vect.h"
#include "plot.h"

#ifdef aiws
extern int hft_fd;
#endif

boolean initialized = FALSE;
int mode;
int pending;

boolean plot_Init()
{
    if (initialized)
        return FALSE;

    mode = fn_Zero;

#ifdef aiws
    hft_fd = hft_open();
    if (hft_fd < 0)
	return FALSE;
#endif
    if(apa16_Init()!=0)
	return FALSE;

    apa16_Fill(0, 0, SCREEN_WD, SCREEN_HT, fn_One);
    apa16_Run();

    initialized = TRUE;
    pending = 0;
}

void plot_Done()
{
    plot_Flush();
    /* FIX THIS! */
}

void plot_GetSize(v)
VECT *v;
{
    vect_SetXY(v, SCREEN_WD, SCREEN_HT);
}

void plot_SetMode(m)
enum plot_MODE m;
{
    switch (m) {
        case plot_SET:
            mode = fn_Zero;
            break;

        case plot_RES:
            mode = fn_One;
            break;

        case plot_INV:
            mode = fn_Xor;
            break;
    }
}

void plot_Clear()
{
    apa16_Fill(0, 0, SCREEN_WD, SCREEN_HT, mode);
    pending=1;
}

void plot_Flush()
{
    if(pending){  /* apa16_Run() doesn't seem to work in the null case */
	apa16_Run();
	pending=0;
    }
}
