#ifndef plot_bitmap_h
#define plot_bitmap_h

#include "bitmap.h"

extern BITMAP *plot_dpy;
extern enum plot_MODE plot_Mode;
extern int plot_curX, plot_curY;

#define plot_SetMode(mode) { plot_Mode = mode; }

#define plot_Move(v) { \
    plot_curX = vect_GetX(v); \
    plot_curY = vect_GetY(v); \
}

#define plot_SetLine(v) { \
    bitmap_SetLine(plot_dpy, plot_curX, plot_curY, vect_GetX(v), vect_GetY(v)); \
    plot_curX = vect_GetX(v); \
    plot_curY = vect_GetY(v); \
}

#define plot_ResLine(v) { \
    bitmap_ResLine(plot_dpy, plot_curX, plot_curY, vect_GetX(v), vect_GetY(v)); \
    plot_curX = vect_GetX(v); \
    plot_curY = vect_GetY(v); \
}

#define plot_InvLine(v) { \
    bitmap_InvLine(plot_dpy, plot_curX, plot_curY, vect_GetX(v), vect_GetY(v)); \
    plot_curX = vect_GetX(v); \
    plot_curY = vect_GetY(v); \
}

#define plot_Line(v) { \
    switch (plot_Mode) \
      { \
      case plot_SET: \
	  plot_SetLine(v); \
	  break; \
      case plot_RES: \
	  plot_ResLine(v); \
	  break; \
      case plot_INV: \
	  plot_InvLine(v); \
      } \
}

#define plot_GetSize(v) { \
    vect_SetXY(v, plot_dpy->width, plot_dpy->height); \
}			  

#define plot_Flush() ;

#define plot_ClearBlack() bitmap_ClearBlack(plot_dpy)
#define plot_ClearWhite() bitmap_ClearWhite(plot_dpy)

#endif plot_bitmap_h
