#ifndef plot_h
#define plot_h

#include "sys.h"
#include "type.h"

extern int mode;

enum plot_MODE {
    plot_SET,
    plot_RES,
    plot_INV
};

#ifndef MPEL
#ifdef aiws
#include "plot.aiws.h"
#endif
#else
#include "plot.mega.h"
#endif

#ifdef APA16
#include "plot.apa16.h"
#endif

#ifdef SUNBW
#include "plot.sunbw.h"
#endif

#ifdef SUNCOLOR
#include "plot.sunc.h"
#endif

#ifdef MIPSCOLOR
#include "plot.mipscolor.h"
#endif

#ifdef XWINDOWS
#include "plot.xwin.h"
#endif




boolean plot_Init();
void plot_Done();

#ifndef plot_GetSize
void plot_GetSize();
#endif

#ifndef plot_SetMode
void plot_SetMode();
#endif

#ifndef plot_Clear
void plot_Clear();     /* Sensitive to current mode */
#endif

#ifndef plot_Move
void plot_Move();
#endif

#ifndef plot_SetLine
void plot_SetLine();
#endif

#ifndef plot_ResLine
void plot_ResLine();
#endif

#ifndef plot_InvLine
void plot_InvLine();
#endif

#ifndef plot_Line
void plot_Line();
#endif

#ifndef plot_Flush
void plot_Flush();
#endif

#ifndef plot_SaveState
void plot_SaveState();
#endif

#ifndef plot_RestoreState
void plot_RestoreState();
#endif

#endif plot_h
