
#include <stdio.h>
#include "plot.h"
#include <X11/cursorfont.h>

#ifndef MAX
#define MAX(a, b) ((a) < (b) ? (b) : (a))
#endif

int plot_curX, plot_curY;
unsigned int plot_maxX, plot_maxY;
Window plot_window;
Display *plot_display;
GC curGC, setGC, resGC, invGC;
boolean plot_Init() 
{
    Screen *plot_screen;
    XSetWindowAttributes attrib;
    Cursor cursor;
    XColor sb, eb;
   
    if (!(plot_display = XOpenDisplay("")))
	return(FALSE);
    plot_screen = XScreenOfDisplay(plot_display, DefaultScreen(plot_display));
    plot_maxX = WidthOfScreen(plot_screen);
    plot_maxY = HeightOfScreen(plot_screen);
    plot_window = XCreateSimpleWindow(plot_display, 
				      RootWindowOfScreen(plot_screen), 
				      0, 0, plot_maxX, plot_maxY,
				      0, WhitePixelOfScreen(plot_screen), 
				      BlackPixelOfScreen(plot_screen));
    attrib.override_redirect = 1;
    XChangeWindowAttributes(plot_display, plot_window, 
			    CWOverrideRedirect, &attrib);

    setGC = XCreateGC(plot_display, plot_window, 0, 
		      (XGCValues *) 0);
    XCopyGC(plot_display, DefaultGCOfScreen(plot_screen), 
	    (1 << (GCLastBit + 1)) - 1, setGC);
    XSetForeground(plot_display, setGC, WhitePixelOfScreen(plot_screen));
    XSetBackground(plot_display, setGC, BlackPixelOfScreen(plot_screen));
    XSetFunction(plot_display, setGC, GXcopy);

    resGC = XCreateGC(plot_display, plot_window, 0, 
		      (XGCValues *) 0);
    XCopyGC(plot_display, DefaultGCOfScreen(plot_screen), 
	    (1 << (GCLastBit + 1)) - 1, resGC);
    XSetForeground(plot_display, resGC, BlackPixelOfScreen(plot_screen));
    XSetBackground(plot_display, resGC, BlackPixelOfScreen(plot_screen));
    XSetFunction(plot_display, resGC, GXcopy);

    invGC = XCreateGC(plot_display, plot_window, 0, 
		      (XGCValues *) 0);
    XCopyGC(plot_display, DefaultGCOfScreen(plot_screen), 
	    (1 << (GCLastBit + 1)) - 1, invGC);
    XSetForeground(plot_display, invGC, MAX(WhitePixelOfScreen(plot_screen), BlackPixelOfScreen(plot_screen)));
    XSetBackground(plot_display, invGC, BlackPixelOfScreen(plot_screen));
    XSetFunction(plot_display, invGC, GXxor);

    XSelectInput(plot_display, plot_window, KeyPressMask|KeyReleaseMask);
    curGC = setGC;

    cursor = XCreateFontCursor(plot_display, XC_dot);
    XAllocNamedColor(plot_display, DefaultColormapOfScreen(plot_screen),
		     "black", &sb, &eb);
    XRecolorCursor(plot_display, cursor, &sb, &sb);
    XDefineCursor(plot_display, plot_window, cursor);

    XMapRaised(plot_display, plot_window);
    XGrabKeyboard(plot_display, plot_window, TRUE, GrabModeAsync, GrabModeAsync, CurrentTime);
    XSync(plot_display, FALSE);
    return(TRUE);
}

void plot_Done(){}
