/*
 * X-windows plotting support
 */

#ifndef _h_plot_xwin
#define _h_plot_xwin

#include <X11/Xlib.h>


extern int plot_curX, plot_curY;
extern unsigned int plot_maxX, plot_maxY;
extern Window plot_window;
extern Display *plot_display;
extern GC curGC, setGC, resGC, invGC;

#define plot_SetMode(mode)  \
    switch(mode) { \
    case plot_SET : \
	curGC = setGC;\
	break; \
    case plot_RES : \
	curGC = resGC;\
	break; \
    case plot_INV : \
	curGC = invGC;\
	break; \
    } 

#define plot_Move(v) { \
    plot_curX = vect_GetX(v); \
    plot_curY = vect_GetY(v); \
}

#define plot_Line(v) { \
    int x, y; \
    x = plot_curX; \
    y = plot_curY; \
    plot_curX = vect_GetX(v); \
    plot_curY = vect_GetY(v); \
    XDrawLine(plot_display, plot_window, curGC, x, y, plot_curX, plot_curY);\
}

#define plot_SetLine(v) { \
        curGC = setGC;\
	plot_Line(v); \
}

#define plot_ResLine(v) { \
        curGC = resGC;\
	plot_Line(v); \
}

#define plot_InvLine(v) { \
        curGC = invGC;\
	plot_Line(v); \
}
#define plot_GetSize(v) { \
    vect_SetXY(v, plot_maxX, plot_maxY); \
}			  

#define plot_Flush() XSync(plot_display, FALSE)

#define plot_ClearBlack() XFillRectangle(plot_display, plot_window, resGC, \
					 0, 0, plot_maxX, plot_maxY)
#define plot_ClearWhite() XFillRectangle(plot_display, plot_window, setGC, \
					 0, 0, plot_maxX, plot_maxY)
#define plot_Clear() XFillRectangle(plot_display, plot_window, curGC, \
					 0, 0, plot_maxX, plot_maxY)
#endif /* plot_xwin_h
