#ifndef shape_h
#define shape_h

#include "type.h"
#include "line.h"
#include "frac.h"
#include "plot.h"

#define SHAPE struct shape

struct shape {
    LINE *segs;         /* Segments */
    int count;          /* Segments used */
    int alloc;          /* Segments allocated */

    long rad;           /* Internally computed */
};

SHAPE *shape_Create();
void shape_Destroy();
void shape_Copy();

SHAPE *shape_CreatePolygon();

void shape_Insert();
boolean shape_Enumerate();

void shape_Scale();
void shape_Rotate();

long shape_GetRadius();
void shape_GetBoxSize();

void shape_Draw();
boolean shape_Collision();
boolean shape_PointInside();
boolean shape_LineTouches();

#endif shape_h
