#ifndef ship_h
#define ship_h

#include "sprite.h"
#include "mlist.h"
#include "debris.h"
#include "param.h"

struct ship {
    SPRITE *sprite;
    SPRITE *flames;
    int hyperspace;
    boolean thrusting, rotleft, rotright;
    boolean boom;
    MLIST *missiles;
    DEBRIS *debris;
};

#define SHIP struct ship

void ship_GlobalInit();
SHIP *ship_Create();
void ship_Destroy();

void ship_Start();

void ship_On(), ship_Off();

#define ship_GetPos(s, v) sprite_GetPos((s)->sprite, (v))
#define ship_GetVel(s,v) sprite_GetVel((s)->sprite, (v))
#define ship_GetVelMul(s, f) sprite_GetVelMul((s)->sprite, (f))
#define ship_GetMissiles(s) ((s)->missiles)
#define ship_GetCurShape(s) sprite_GetCurShape((s)->sprite)
#define ship_GetCurIndex(s) sprite_GetIndex((s)->sprite)
#define ship_GetSprite(s) ((s)->sprite)
#define ship_IsExploding(s) ((s)->boom)
#define ship_IsInHyperspace(s) ((s)->hyperspace>0)

void ship_Update();
void ship_Command();

void ship_GlobalSetBounce();

#endif
