#include "sound.h"

#if defined(__sparc__) || defined(sparc)
#define sunos41
#include "libsst.c"
#endif
/*
 * This is a no-op file.
 * The sun does not have sound.
 * but the sparcstation has
 */

#if defined(__sparc__) || defined(sparc)
private int s_fd;
private int s_on;
#endif
boolean sound_GlobalInit()
{
#if defined(__sparc__) || defined(sparc)
    s_fd = sst_open();
    if (s_fd == -1) {
	s_on = TRUE;
	return FALSE;
    }
    else {
	s_on = FALSE;
	return TRUE;
    }
#else
    return FALSE;

#endif
}

void sound_Done()
{
#if defined(__sparc__) || defined(sparc)
    sst_close(s_fd);
    s_on = FALSE;
#endif
}

void sound_On()
{
#if defined(__sparc__) || defined(sparc)
   s_on = TRUE;
#endif
}

void sound_Off()
{
#if defined(__sparc__) || defined(sparc)
   s_on = FALSE;
#endif
}

void sound_Play(f, d, v)
unsigned short f, d, v;
{
#if defined(__sparc__) || defined(sparc)
   if (s_on) {
#ifdef 0
       printf("s_fd = %d f = %d d = %d\n", s_fd, f, d);
#endif
       sst_tones(s_fd, (int) f, (int) f, (int) 0, (int) 0, (int) d * 20);
    }
#endif
}
