#ifndef soundeff_h
#define soundeff_h

#include "sound.h"
#include "rand.h"

#define LOVOL 16384
#define HIVOL 65535

#define soundeff_ShipFire() { \
    sound_Play(1700, 1, LOVOL); \
    sound_Play(1400, 1, LOVOL); \
    sound_Play(1100, 1, LOVOL); \
}

#define soundeff_AlienFire() { \
    sound_Play(3000, 2, LOVOL); \
    sound_Play(2500, 2, LOVOL); \
    sound_Play(2000, 2, LOVOL); \
}

#define soundeff_AstExplode() { \
     sound_Play(20 + rand_Natural(200), 1, LOVOL); \
     sound_Play(20 + rand_Natural(200), 1, LOVOL); \
     sound_Play(20 + rand_Natural(200), 1, LOVOL); \
     sound_Play(20 + rand_Natural(200), 1, LOVOL); \
     sound_Play(20 + rand_Natural(200), 1, LOVOL); \
     sound_Play(20 + rand_Natural(200), 1, LOVOL); \
}

#define soundeff_ShipExplode() { \
     sound_Play(261, 112, LOVOL); \
     sound_Play(0, 16, LOVOL); \
     sound_Play(261, 32, LOVOL); \
     sound_Play(348, 224, LOVOL); \
}

#define soundeff_AlienPoints() { \
     sound_Play(100, 2, LOVOL); \
     sound_Play(200, 2, LOVOL); \
     sound_Play(400, 2, LOVOL); \
     sound_Play(800, 2, LOVOL); \
     sound_Play(1600, 2, LOVOL); \
 }

#define soundeff_AlienExplode() { \
     soundeff_AstExplode(); \
}

/*
 * ExtraMan used to be at HIVOL, except it was very, very loud and
 * obnoxious on the RTs.  Also shortened the beeps a little.
 */

#define soundeff_ExtraMan() { \
    sound_Play(2400, 60, LOVOL); \
    sound_Play(0, 80, LOVOL); \
    sound_Play(2400, 60, LOVOL); \
    sound_Play(0, 80, LOVOL); \
    sound_Play(2400, 60, LOVOL); \
}

#define soundeff_LowDeet() { /* The background noise */ \
    sound_Play(110, 15, LOVOL); \
}

#define soundeff_HighDeet() { /* The background noise */ \
    sound_Play(130, 15, LOVOL); \
}
#define soundeff_Thrust() { \
     sound_Play(20 + rand_Natural(200), 1, LOVOL); \
     sound_Play(20 + rand_Natural(200), 1, LOVOL); \
}

#endif soundeff_h
