#include "text.h"
#include "plot.h"

InitState(ts)
struct textstate *ts;
{
    ts->str[0]='\0';
    ts->font = NULL;
    vect_SetXY(&ts->pos, 0, 0);
    ts->on = FALSE;
}

TEXT *text_Create()
{
    TEXT *t=New(TEXT);

    InitState(&t->state);
    InitState(&t->oldState);

    return t;
}

void text_Destroy(t)
TEXT *t;
{
    text_Off(t);
    text_Update(t);
    Zap(t);
}

void text_GetSize(t,v)
TEXT *t;
VECT *v;
{
    VECT spacing;
    linefont_GetCharSpacing(t->state.font, &spacing);
    vect_SetX(v, strlen(t->state.str) * vect_GetX(&spacing));
    linefont_GetLineSpacing(t->state.font, &spacing);
    vect_SetY(v, vect_GetY(&spacing));
}

static void DrawString(pos,font,str)
VECT *pos;
LINEFONT *font;
char *str;
{
    VECT chs,curpos;

    linefont_GetMaxSize(font, &chs);
    vect_Copy(&curpos, pos);
    vect_SetY(&curpos, vect_GetY(&curpos) + vect_GetY(&chs));
    linefont_GetCharSpacing(font, &chs);

    while (*str != '\0') {
	shape_Draw(linefont_Get(font,* str), &curpos);
        vect_Add(&curpos, &chs);
	str++;
    }

    plot_Flush();
}

void text_Update(t)
TEXT *t;
{
    if ((bcmp(&t->oldState, &t->state, sizeof (struct textstate)) != 0 ||
	!t->state.on) &&
       t->oldState.on && t->oldState.font != NULL) {
	plot_SetMode(plot_RES);
	DrawString(&t->oldState.pos, t->oldState.font, t->oldState.str);
    }

    if (t->state.on && t->state.font != NULL) {
        plot_SetMode(plot_SET);
        DrawString(&t->state.pos, t->state.font, t->state.str);
    }

    t->oldState = t->state;
}
