#ifndef text_h
#define text_h

#include "linefont.h"
#include "type.h"
#include "vect.h"

#define TEXT struct text

#define MAXTEXT 80

struct textstate {
    char str[MAXTEXT];
    VECT pos;
    boolean on;
    LINEFONT *font;
};

struct text {
    struct textstate state, oldState;
};

TEXT *text_Create();
void text_Destroy();

#define text_On(t) ((t)->state.on = TRUE)
#define text_Off(t) ((t)->state.on = FALSE)

void text_GetSize();    /* Get size of box required by text (pixels) */

#define text_Get(t) ((t)->state.str)
#define text_Set(t,s) strncpy((t)->state.str, (s), MAXTEXT)

#define text_SetPos(t, v) vect_Copy(&(t)->state.pos, v)
#define text_GetPos(t, v) vect_Copy(v, &(t)->state.pos)

#define text_SetFont(t, lf) ((t)->state.font = (lf))
#define text_GetFont(t) ((t)->state.font)

void text_Update();

#endif text_h
