#include "type.h"
#include "updlist.h"

#define BUMP 6

UPDLIST *updlist_Create()
{
    UPDLIST *u=New(UPDLIST);
    u->num=0;
    u->alloc=1;
    u->procs=(void (**)())malloc(sizeof(void (*)()));
    u->rocks=(char **)malloc(sizeof(char *));
    return u;
}

void updlist_Destroy(u)
UPDLIST *u;
{
    free((char *)u->rocks);
    free((char *)u->procs);
    Zap(u);
}

void updlist_Add(u,item,proc)
UPDLIST *u;
char *item;
void (*proc)();
{
    if(u->num==u->alloc){
	u->alloc+=BUMP;
	u->procs=(void (**)())realloc(u->procs,u->alloc*sizeof(void (*)()));
	u->rocks=(char **)realloc(u->rocks,u->alloc*sizeof(char *));
    }

    u->rocks[u->num]=item;
    u->procs[u->num]=proc;
    u->num++;
}

void updlist_Remove(u,item)
UPDLIST *u;
char *item;
{
    int i;

    for(i=0; i<u->num; i++)
	if(u->rocks[i]==item){
	    u->num--;
	    u->rocks[i]=u->rocks[u->num];
	    u->procs[i]=u->procs[u->num];
	    break;
	}
}

void updlist_Update(u)
UPDLIST *u;
{
    int i;

    for(i=0; i<u->num; i++)
	(*u->procs[i])(u->rocks[i]);
}
