/* $Header: util.h,v 1.1 88/12/05 16:11:38 christos Locked $ */
/*
 *
 * util.h : Standard utilities file.
 *
 * Modification history:
 * $Log:	util.h,v $
 */
#ifndef _h_util
#define _h_util

#ifndef TRUE
#define TRUE 			1
#define FALSE 			0
#endif  /* TRUE */

#define private			static
#define public
#define NEW(a)			(a *) Malloc(sizeof(a))
#define NEWN(a, n)		(a *) Malloc(sizeof(a) * (unsigned) (n))
#define DISPOSE(a)		Free((char *) a)
#define SIZEOF(a)		MemPtr((char *) a)
#define NIL(a)			((a *) 0)
#ifndef MIN
#define MIN(a, b) 		((a) > (b) ? (b) : (a))
#endif
#ifndef MAX
#define MAX(a, b) 		((a) < (b) ? (b) : (a))
#endif
#define ABS(a)			((a) < 0 ? -(a) : (a))
#define SGN(a)			((a) > 0 ? 1 : (a) < 0 ? -1 : 0)
#define SQR(a)			((a) * (a))
#define SWAP(a,b)		(a ^= b, b ^= a, a ^= b)
#define MASK(a)			((1 << (a)) - 1)
#define LOW(x)			((x) & 0xff)
#define HIGH(x)			(((x) >> 8) & 0xff)

/*
 * To give a good debugging message and die
 */
#ifdef DEBUG
# ifndef lint
#  define ASSERT(a, m)		{ \
				    if (!(a)) { \
					(void) fprintf(stderr, \
					    "%s (%s at %d), aborting\n", \
					    (m), __FILE__, __LINE__); \
					(void) abort(); \
				    } \
				}
# else /* lint */
#  define ASSERT(a, m)
# endif /* lint */
#else /* DEBUG */
# ifndef lint
#  define ASSERT(a, m)		{ \
				    if (!(a)) { \
					(void) fprintf(stderr, \
					    "%s (%s at %d), exiting\n", \
					    (m), __FILE__, __LINE__); \
					(void) exit(-1); \
				    } \
				}
# else /* lint */
#  define ASSERT(a, m)
# endif /* lint */
#endif /* DEBUG */
				
/*
 *	Utilties for setjmp, longjump
 */
#define CHECKPOINT(m, v)	if ( setjmp(v) ) { \
				    (void) fprintf(stdout, "%s\n", (m)); \
				    return; \
				} 
#define ABORT(c, m, v)		if ( !(c) ) { \
				    (void) fprintf(stdout, "%s, ", (m)); \
				    longjmp(v, 1); \
				} 


#define forever()		for(;;)
#define strdup(_s)		strcpy((char *) \
				    Malloc((unsigned) (strlen(_s) + 1)), _s)

/*
 *	Errors
 */
extern int sys_nerr, errno;
extern char *sys_errlist[];
#define PERROR			(errno >= 0 && errno < sys_nerr ? \
					sys_errlist[errno] : "Unknown Error")
/* some useful constants */
#ifndef MAXFLOAT		/* hack for 4.2 or 4.3 (4.2 has it 4.3 not) */
#define M_E			2.7182818284590452354
#define M_LOG2E			1.4426950408889634074
#define M_LOG10E		0.43429448190325182765
#define M_LN2			0.69314718055994530942
#define M_LN10			2.30258509299404568402
#define M_PI			3.14159265358979323846
#define M_PI_2			1.57079632679489661923
#define M_PI_4			0.78539816339744830962
#define M_1_PI			0.31830988618379067154
#define M_2_PI			0.63661977236758134308
#define M_2_SQRTPI		1.12837916709551257390
#define M_SQRT2			1.41421356237309504880
#define M_SQRT1_2		0.70710678118654752440

#define MAXFLOAT		((float)1.701411733192644299e+38)
#endif /* MAXFLOAT */
#ifndef MINFLOAT
#define MINFLOAT		((float)-1.701411733192644299e+38)
#endif /* MINFLOAT */
#ifndef MAXINT
#define MAXINT			0x7fffffff
#define MININT			0x80000000
#endif /* MAXINT */


/*
 *	From alloc.c
 */
#ifndef lint
/*
 * Fool lint to believe tha Malloc returns aligned pointers...
 */
extern char *		Malloc();
#else
typedef struct bigstruct {
	int a[1000];
} bigstruct;

extern bigstruct *	Malloc();
#endif /* lint */

extern void 		Free();
extern unsigned 	MemStat();
extern unsigned 	MemPtr();

extern void 		Free();
extern unsigned 	MemStat();
extern unsigned 	MemPtr();

/*
 *	From arrayn.c
 */
extern char	*	arrayn();

/*
 *	From egets.c
 */
extern char	*	egets();

#endif /* _h_util */
