#ifndef vect_h
#define vect_h

#define VECT struct vect

struct vect {
    long x, y;
};

#define vect_SetX(v, X) \
        ((v)->x = (X))
#define vect_SetY(v, Y) \
        ((v)->y = (Y))
#define vect_SetXY(v, X, Y) \
        ((v)->x = (X), (v)->y = (Y))

#define vect_GetX(v) \
        ((v)->x)
#define vect_GetY(v) \
        ((v)->y)
#define vect_GetXY(v, X, Y) \
        (*(X) = (v)->x, *(Y) = (v)->y)

#define vect_Copy(v1, v2) \
        (*(v1) = *(v2))

#define vect_Equal(v1, v2) \
        ((v1)->x == (v2)->x && \
         (v1)->y == (v2)->y)

#define vect_Add(v1, v2) \
        ((v1)->x += (v2)->x, \
         (v1)->y += (v2)->y)
#define vect_AddConst(v, c) \
        ((v)->x += (c), \
         (v)->y += (c))
#define vect_Sub(v1, v2) \
        ((v1)->x -= (v2)->x, \
         (v1)->y -= (v2)->y)
#define vect_SubConst(v, c) \
        ((v)->x -= (c), \
         (v)->y -= (c))
#define vect_Mul(v1, v2) \
        ((v1)->x *= (v2)->x, \
         (v1)->y *= (v2)->y)
#define vect_MulConst(v, c) \
        ((v)->x *= (c), \
         (v)->y *= (c))
#define vect_DivConst(v, c) \
        ((v)->x /= (c), \
         (v)->y /= (c))

#define vect_Scale(v, f) \
        (vect_SetX((v), frac_ConstMul(vect_GetX(v), (f))), \
         vect_SetY((v), frac_ConstMul(vect_GetY(v), (f))))
#define vect_SumSqr(v) \
        ((v)->x * (v)->x + (v)->y * (v)->y)

#endif vect_h
